﻿Option Strict On
Imports System.Xml.Linq
Imports System.Device.Location
Imports Microsoft.Phone.Controls.Maps

Partial Public Class MainPage
    Inherits PhoneApplicationPage

    ' コンストラクター
    Public Sub New()
        InitializeComponent()
    End Sub
    Dim no As Integer = 0
    Dim xmldoc As XElement
    Dim menuItemList As New List(Of MenuItem)
    Dim index As Integer = 0
    'Dim mapZoomLevel As String

    Protected Overrides Sub OnNavigatedTo(e As System.Windows.Navigation.NavigationEventArgs)
        'Dim myParam As IDictionary(Of String, String) = NavigationContext.QueryString
        'If myParam.ContainsKey("myZoomLevel") = True Then
        '    mapZoomLevel = myParam("myZoomLevel")
        '    Map1.ZoomLevel = CDbl(mapZoomLevel)
        'Else
        '    Map1.ZoomLevel = 5
        'End If
        Map1.ZoomLevel = 6
        Dim myUri As Uri = New Uri("http://nmz.mogken.com/api?c=10&f=xml", UriKind.Absolute)

        Dim myWebClient As New WebClient
        myWebClient.DownloadStringAsync(myUri)
        Dim detectionDate As String = String.Empty
        Dim myLocation As String = String.Empty
        Dim myLatitude As String = String.Empty
        Dim myLongitude As String = String.Empty
        Dim myMagnitude As String = String.Empty
        Dim myIntensity As String = String.Empty
        Dim nowYear As Integer = Date.Now.Year
        Dim nowMonth As Integer = Date.Now.Month
        Dim nowDay As Integer = Date.Now.Day

        Dim myDate As String = nowYear.ToString & "-" & nowMonth.ToString("00") & "-" & nowDay.ToString("00")

        no = 0
        AddHandler myWebClient.DownloadStringCompleted, Sub(resultSender As Object, resultArgs As DownloadStringCompletedEventArgs)
                                                            xmldoc = XElement.Parse(resultArgs.Result)


                                                            For Each result In From c In xmldoc.Elements("item") Select c
                                                                myLocation = result.Element("epicenter_location_name").Value
                                                                detectionDate = result.Element("detection_date").Value
                                                                myLatitude = result.Element("epicenter_coor_lat").Value
                                                                myLongitude = result.Element("epicenter_coor_long").Value
                                                                myMagnitude = result.Element("magnitude").Value
                                                                myIntensity = result.Element("intensity").Value
                                                                Map1.Center = New GeoCoordinate(Double.Parse(myLatitude), Double.Parse(myLongitude))
                                                                Dim myPin As New Pushpin
                                                                If detectionDate.Contains(myDate) = True Then
                                                                    myPin.Background = New SolidColorBrush(Colors.Red)
                                                                Else
                                                                    myPin.Background = New SolidColorBrush(Colors.Yellow)
                                                                End If

                                                                myPin.Foreground = New SolidColorBrush(Colors.Blue)
                                                                myPin.Location = New GeoCoordinate(Double.Parse(myLatitude), Double.Parse(myLongitude))
                                                                'myPin.Content = "発生日時=" & detectionDate & vbCrLf & "震源地=" & myLocation & vbCrLf & "マグニチュード=" & myMagnitude & "：" & "震度=" & myIntensity
                                                                myPin.Content = "地震発生日時=" & detectionDate
                                                                myPin.Tag = no.ToString
                                                                no = no + 1
                                                                Map1.Children.Add(myPin)


                                                                AddHandler myPin.Hold, AddressOf myPin_Hold
                                                            Next
                                                            Dim myMenuItem As New MenuItem
                                                            myMenuItem.Header = "地震の詳細を表示"
                                                            menuItemList.Add(myMenuItem)
                                                            ContextMenu1.ItemsSource = menuItemList

                                                            AddHandler myMenuItem.Click, AddressOf myMenuItem_Click
                                                        End Sub
        MyBase.OnNavigatedTo(e)
    End Sub

    Private Sub myPin_Hold(sender As Object, e As System.Windows.Input.GestureEventArgs)
        ContextMenu1.IsOpen = True
        index = Integer.Parse(DirectCast(sender, Pushpin).Tag.ToString)
    End Sub

    Private Sub myMenuItem_Click(sender As Object, e As EventArgs)
        Dim selectHeader = DirectCast(sender, MenuItem).Header

        Select Case selectHeader.ToString
            Case "地震の詳細を表示"
                Dim location As String = xmldoc.Elements("item")(index).Element("epicenter_location_name").Value '震源地
                Dim quakeDate As String = xmldoc.Elements("item")(index).Element("detection_date").Value '発生日時
                Dim intnsity As String = xmldoc.Elements("item")(index).Element("intensity").Value '震度
                Dim magnitude As String = xmldoc.Elements("item")(index).Element("magnitude").Value 'マグニチュード
                NavigationService.Navigate(New Uri(String.Format("/DetailsPage.xaml?myDate={0}&myPlace={1}&myMagnitude={2}&myIntnisity={3}", quakeDate, location, magnitude, intnsity), UriKind.Relative))
            Case Else
                Exit Sub

        End Select
    End Sub

   
End Class
